package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.PrintWriter;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityResponseWriter;

import org.custommonkey.xmlunit.XMLAssert;
import org.custommonkey.xmlunit.XMLUnit;
import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.mock.servlet.MockHttpServletResponse;

public class EntityResponseWriterComponentTest extends
        S2TestCase {
    EntityResponseWriter entityResponseWriter;

    public void setUp() throws Exception {
        include("EntityResponseWriterComponentTest.dicon");
        XMLUnit.setIgnoreWhitespace(true);
    }

    public void testHttpServletResponseEntityXMLďo()
            throws Exception {
        SampleEntity2 entity = new SampleEntity2();
        entity.setId(1000);
        entity.setNickName("daemon lord");

        // S2Unit񋟂郂bN̂܂܎g
        MockHttpServletResponse mockResponse = getResponse();
        entityResponseWriter.writeEntityTo(
                mockResponse, entity);

        assertEquals("text/xml",
                mockResponse.getContentType());
        assertEquals("UTF-8",
                mockResponse.getCharacterEncoding());

        String expected = "<sampleEntity2>"
                + "<id>1000</id><nickName>daemon lord</nickName>"
                + "</sampleEntity2>";
        PrintWriter actualWriter = mockResponse.getWriter();
        XMLAssert.assertXMLEqual(expected,
                actualWriter.toString());
    }
}
